/*
 * Copyright (c) 2022 Michael G. Katzmann
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/

#include <glib-2.0/glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

/* XPM */
const char * HP_128_xpm[] = {
"128 128 304 2",
"  	c None",
". 	c #000080",
"+ 	c #020280",
"@ 	c #6E6E9E",
"# 	c #FFFFFF",
"$ 	c #7777A4",
"% 	c #080882",
"& 	c #8181A9",
"* 	c #B3B3C8",
"= 	c #C4C4D4",
"- 	c #EBEBF0",
"; 	c #C6C6D5",
"> 	c #616198",
", 	c #232385",
"' 	c #F6F6F8",
") 	c #B9B9CB",
"! 	c #141482",
"~ 	c #F5F5F7",
"{ 	c #E8E8EE",
"] 	c #9B9BB8",
"^ 	c #606098",
"/ 	c #9191B2",
"( 	c #BABACC",
"_ 	c #DEDEE6",
": 	c #E2E2E9",
"< 	c #D2D2DD",
"[ 	c #7171A0",
"} 	c #070781",
"| 	c #9999B7",
"1 	c #ACACC3",
"2 	c #393989",
"3 	c #F9F9FB",
"4 	c #B0B0C6",
"5 	c #B8B8CE",
"6 	c #B6B6CC",
"7 	c #ADADC4",
"8 	c #AAAAC1",
"9 	c #8E8EB1",
"0 	c #6F6F9F",
"a 	c #040480",
"b 	c #4D4D8F",
"c 	c #B7B7CB",
"d 	c #F3F3F6",
"e 	c #FEFEFE",
"f 	c #4E4E90",
"g 	c #9D9DB9",
"h 	c #FCFCFD",
"i 	c #E2E2EA",
"j 	c #BFBFD0",
"k 	c #8B8BAE",
"l 	c #090981",
"m 	c #41418C",
"n 	c #C0C0D1",
"o 	c #FAFAFB",
"p 	c #DADAE3",
"q 	c #C7C7D6",
"r 	c #7979A4",
"s 	c #A4A4BE",
"t 	c #4F4F90",
"u 	c #FDFDFE",
"v 	c #E1E1E9",
"w 	c #8C8CAF",
"x 	c #5B5B95",
"y 	c #DDDDE5",
"z 	c #383889",
"A 	c #ABABC3",
"B 	c #7878A3",
"C 	c #8D8DAF",
"D 	c #C5C5D5",
"E 	c #383888",
"F 	c #ADADC3",
"G 	c #9090B1",
"H 	c #EEEEF2",
"I 	c #C3C3D3",
"J 	c #F5F5F8",
"K 	c #161682",
"L 	c #B8B8CB",
"M 	c #FBFBFC",
"N 	c #A5A5BF",
"O 	c #C9C9D6",
"P 	c #EBEBF1",
"Q 	c #C1C1D2",
"R 	c #B8B8CC",
"S 	c #8080A8",
"T 	c #7777A3",
"U 	c #CBCBD8",
"V 	c #010180",
"W 	c #A3A3BD",
"X 	c #EFEFF3",
"Y 	c #C2C2D2",
"Z 	c #CACAD8",
"` 	c #BDBDCE",
" .	c #3B3B8A",
"..	c #69699C",
"+.	c #CBCBD9",
"@.	c #E6E6ED",
"#.	c #CDCDDA",
"$.	c #6A6A9C",
"%.	c #8888AC",
"&.	c #B2B2C7",
"*.	c #2C2C86",
"=.	c #F7F7F9",
"-.	c #252584",
";.	c #181883",
">.	c #565693",
",.	c #9797B6",
"'.	c #B9B9CC",
").	c #A9A9C1",
"!.	c #D7D7E1",
"~.	c #68689B",
"{.	c #262685",
"].	c #F2F2F6",
"^.	c #46468D",
"/.	c #FBFBFD",
"(.	c #D5D5E0",
"_.	c #A8A8C0",
":.	c #42428C",
"<.	c #7C7CA6",
"[.	c #D6D6E0",
"}.	c #68689C",
"|.	c #8484AB",
"1.	c #8C8CB0",
"2.	c #AEAEC4",
"3.	c #DFDFE7",
"4.	c #9797B7",
"5.	c #7070A1",
"6.	c #7676A3",
"7.	c #8989AD",
"8.	c #BEBECF",
"9.	c #D8D8E2",
"0.	c #8585AA",
"a.	c #9696B4",
"b.	c #FDFDFD",
"c.	c #44448C",
"d.	c #E0E0E8",
"e.	c #6D6D9E",
"f.	c #272785",
"g.	c #BABACD",
"h.	c #3A3A89",
"i.	c #C5C5D4",
"j.	c #131382",
"k.	c #F6F6F9",
"l.	c #4C4C90",
"m.	c #1B1B83",
"n.	c #8888AD",
"o.	c #323289",
"p.	c #5A5A99",
"q.	c #F1F1F6",
"r.	c #7B7BA4",
"s.	c #5E5E96",
"t.	c #AAAAC0",
"u.	c #F2F2F5",
"v.	c #EDEDF2",
"w.	c #F2F2F7",
"x.	c #C1C1D1",
"y.	c #F0F0F4",
"z.	c #9898B6",
"A.	c #F8F8FA",
"B.	c #2B2B86",
"C.	c #DCDCE5",
"D.	c #F1F1F5",
"E.	c #7373A2",
"F.	c #8383AA",
"G.	c #646499",
"H.	c #9E9EBA",
"I.	c #4D4D90",
"J.	c #FEFEFF",
"K.	c #626298",
"L.	c #7575A2",
"M.	c #EAEAF0",
"N.	c #C8C8D6",
"O.	c #E4E4EB",
"P.	c #AAAAC2",
"Q.	c #A0A0BB",
"R.	c #B8B8CA",
"S.	c #191982",
"T.	c #43438C",
"U.	c #F3F3F7",
"V.	c #B4B4C9",
"W.	c #5D5D97",
"X.	c #9393B3",
"Y.	c #505091",
"Z.	c #DEDEE7",
"`.	c #5A5A95",
" +	c #D9D9E3",
".+	c #CCCCD8",
"++	c #D3D3DE",
"@+	c #DCDCE4",
"#+	c #9696B5",
"$+	c #585894",
"%+	c #7A7AA4",
"&+	c #CFCFDC",
"*+	c #ABABC2",
"=+	c #3D3D8A",
"-+	c #9F9FBB",
";+	c #282885",
">+	c #E7E7ED",
",+	c #FAFAFC",
"'+	c #4C4C8F",
")+	c #9F9FBA",
"!+	c #CCCCD9",
"~+	c #6C6C9E",
"{+	c #030381",
"]+	c #E5E5EB",
"^+	c #DBDBE4",
"/+	c #ECECF1",
"(+	c #636399",
"_+	c #9C9CB8",
":+	c #515191",
"<+	c #9494B3",
"[+	c #030380",
"}+	c #EFEFF4",
"|+	c #37378C",
"1+	c #E3E3EA",
"2+	c #343488",
"3+	c #171782",
"4+	c #35358A",
"5+	c #D5D5E1",
"6+	c #D0D0DC",
"7+	c #E3E3EB",
"8+	c #060681",
"9+	c #8282A9",
"0+	c #C7C7D5",
"a+	c #1E1E84",
"b+	c #8F8FB1",
"c+	c #8484AA",
"d+	c #151582",
"e+	c #111182",
"f+	c #F4F4F7",
"g+	c #BDBDCF",
"h+	c #5F5F98",
"i+	c #9292B2",
"j+	c #3A3A8A",
"k+	c #E6E6EC",
"l+	c #8383A9",
"m+	c #7E7EA7",
"n+	c #7A7AA5",
"o+	c #D1D1DD",
"p+	c #EEEEF3",
"q+	c #BCBCCD",
"r+	c #B4B4C8",
"s+	c #45458D",
"t+	c #DADAE4",
"u+	c #CCCCDA",
"v+	c #66669B",
"w+	c #595994",
"x+	c #A6A6BF",
"y+	c #C8C8D7",
"z+	c #44448D",
"A+	c #E5E5EC",
"B+	c #CECEDB",
"C+	c #505090",
"D+	c #46468E",
"E+	c #B1B1C6",
"F+	c #2F2F86",
"G+	c #A7A7C0",
"H+	c #545492",
"I+	c #7474A2",
"J+	c #333388",
"K+	c #49498E",
"L+	c #2A2A86",
"M+	c #F1F1F4",
"N+	c #AFAFC5",
"O+	c #40408B",
"P+	c #7878A4",
"Q+	c #D8D8E1",
"R+	c #4F4F91",
"S+	c #BCBCCE",
"T+	c #6B6B9D",
"U+	c #8A8AAE",
"V+	c #1D1D83",
"W+	c #292985",
"X+	c #DDDDE6",
"Y+	c #D6D6E1",
"Z+	c #66669A",
"`+	c #333387",
" @	c #A5A5BE",
".@	c #8787AB",
"+@	c #3F3F8C",
"@@	c #9595B5",
"#@	c #9494B4",
"$@	c #9797B5",
"%@	c #575793",
"&@	c #242485",
"*@	c #C9C9D7",
"=@	c #2D2D86",
"-@	c #65659A",
";@	c #9D9DBA",
">@	c #F9F9FA",
",@	c #373788",
"'@	c #5E5E97",
")@	c #6A6A9D",
"!@	c #0A0A81",
"~@	c #0C0C82",
"{@	c #8A8AAD",
"]@	c #B5B5C9",
"^@	c #7C7CA4",
"/@	c #7777A2",
"(@	c #47478F",
"_@	c #626299",
":@	c #A2A2BD",
"<@	c #E9E9EE",
"[@	c #9C9CB9",
"}@	c #9A9AB8",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"            . . . . . . . . + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + @ # # # # $ % % % % % % % & # # # # * + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + . . . . . . .             ",
"        . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . = # # # - . . . . . . . . ; # # # # > . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .         ",
"      . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . , ' # # # ) . . . . . . . ! ~ # # # { . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .       ",
"    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ] # # # # ^ . . . . . . . / # # # # ( . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .     ",
"  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . _ # # # : . . . . . . . . < # # # # [ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
"  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . } | # # # # 1 . . . . . . . 2 3 # # # 3 4 5 6 7 8 9 0 a . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . b c d # # # # e f . . . . . . . g # # # # # # # # # # # # h i j k l . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . m n o # # # # # # p . . . . . . . . p # # # # # # # # # # # # # # # # ' q r . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . s ' # # # # # # # # g . . . . . . . t u # # # # # # # # # # # # # # # # # # # v w . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . x y # # # # # # # # # 3 z . . . . . . . A # # # # # # # # # # # # # # # # # # # # # # : B . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . C ' # # # # # # # # # # < . . . . . . . . i # # # # # # # # # # # # # # # # # # # # # # # # D E . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . F e # # # # # # # # # # # G . . . . . . . > # # # # # # # # # # # # # # # # # # # # # # # # # # H r . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . I # # # # # # # # # # # # J K . . . . . . . L # # # # # # # # # # # # # # # # # # # # # # # # # # # M N . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . O # # # # # # # # # # # # # ; . . . . . . . . P # # # # # # # # # # # # # # # # # # # # # # # # # # # # # Q . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . R # # # # # # # # # # # # # # S . . . . . . . T # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # U V . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . W # # # # # # # # # # # # # # X . . . . . . . . Y # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # Z . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . r M # # # # # # # # # # # # # # ` . . . . . . . V d # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # R . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .  .X # # # # # # # # # # # # # # # ... . . . . . . k # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # | . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +.# # # # # # # # # # # # # # # @.. . . . . . . . #.# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # o $.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . %.# # # # # # # # # # # # # # # # &.. . . . . . . *.=.# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # { -.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ;.- # # # # # # # # # # # # # # # # >.. . . . . . . ,.# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # '.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ).# # # # # # # # # # # # # # # # y . . . . . . . . !.# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # M ~.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . {.].# # # # # # # # # # # # # # # # s . . . . . . . ^./.# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # (.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . _.# # # # # # # # # # # # # # # # M :.. . . . . . . N # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # <.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . - # # # # # # # # # # # # # # # # [.. . . . . . . . }.|.|.|.|.|.1.2.3.# # # # # # # # # 4.5.5.5.5.5.5.5.5.5.5.5.5.5.6.7.8.' # # # # # # 9.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . 0.# # # # # # # # # # # # # # # # # a.. . . . . . . . . . . . . . . . . ] b.# # # # # # X . . . . . . . . . . . . . . . . . c.d.# # # # # # e.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . +.# # # # # # # # # # # # # # # # =.f.. . . . . . . . . . . . . . . . . . g.# # # # # # ` . . . . . . . . . . . . . . . . . . h.d # # # # # i.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . j.k.# # # # # # # # # # # # # # # # +.. . . . . . . . . . . . . . . . . . . l.# # # # # # ... . . . . . . . . . . . . . . . . . . j # # # # # J m.. . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . k # # # # # # # # # # # # # # # # # n.. . . . . . . o.p.p.p.p.V . . . . . . . q.# # # # @.. . . . . . . . @ r.r.r.s.. . . . . . . t.# # # # # # / . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . 8.# # # # # # # # # # # # # # # # u.+ . . . . . . . ` # # # v.. . . . . . . . w.# # # # &.. . . . . . . *.=.# # # | . . . . . . . c # # # # # # Z . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . i # # # # # # # # # # # # # # # # x.. . . . . . . . y.# # # '.. . . . . . . ^.# # # # # >.. . . . . . . z.# # # A.B.. . . . . . . C.# # # # # # D.. . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . j.u # # # # # # # # # # # # # # # # E.. . . . . . . F.# # # # G.. . . . . . . H.# # # # y . . . . . . . . !.# # # #.. . . . . . . I.J.# # # # # # # K.. . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . L.# # # # # # # # # # # # # # # # M.. . . . . . . . N.# # # O.. . . . . . . . p # # # # s . . . . . . . ^./.# # # C . . . . . . . P.# # # # # # # # H.. . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . Q.# # # # # # # # # # # # # # # # R.. . . . . . . S.J # # # 2.. . . . . . . f e # # # M T.. . . . . . . N # # # U.V . . . . . . . d.# # # # # # # # Y . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . V.# # # # # # # # # # # # # # # # W.. . . . . . . X.# # # e Y.. . . . . . . F # # # # [.. . . . . . . . Z.# # # Y . . . . . . . `.# # # # # # # # #  +. . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . .+# # # # # # # # # # # # # # # v . . . . . . . . ++# # # @+. . . . . . . . i # # # # #+. . . . . . . $+# # # # %+. . . . . . . * # # # # # # # # # { . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . &+# # # # # # # # # # # # # # # *+. . . . . . . =+o # # # -+. . . . . . . ^ # # # # =.;+. . . . . . . &.# # # v.. . . . . . . . >+# # # # # # # # # ,+. . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . : # # # # # # # # # # # # # # u '+. . . . . . . )+# # # ,+ .. . . . . . . ) # # # # !+. . . . . . . . >+# # # '.. . . . . . . ~+# # # # # # # # # # # {+. . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . ]+# # # # # # # # # # # # # #  +. . . . . . . . ^+# # # ++. . . . . . . . /+# # # # 7.. . . . . . . e.# # # # (+. . . . . . . ` # # # # # # # # # # # ;+. . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . ]+# # # # # # # # # # # # # # _+. . . . . . . :+e # # # <+. . . . . . . T # # # # d [+. . . . . . . ` # # # O.. . . . . . . . }+# # # # # # # # # # # |+. . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . 1+# # # # # # # # # # # # # 3 2+. . . . . . . 7 # # # ' 3+. . . . . . . Y # # # # x.. . . . . . . . y.# # # 2.. . . . . . . & # # # # # # # # # # # # 4+. . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . 5+# # # # # # # # # # # # # 6+. . . . . . . . 7+# # # N.. . . . . . . 8+d # # # # L.. . . . . . . 9+# # # e t . . . . . . . 0+# # # # # # # # # # # # a+. . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . .+# # # # # # # # # # # # # b+. . . . . . . G.# # # # c+. . . . . . . k # # # # - . . . . . . . . q # # # ^+. . . . . . . d+J # # # # # # # # # # # # . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . j # # # # # # # # # # # # ~ e+. . . . . . . ) # # # D.. . . . . . . . #.# # # # L . . . . . . . d+J # # # Q.. . . . . . . / # # # # # # # # # # # # f+. . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . _.# # # # # # # # # # # # i.. . . . . . . . v.# # # g+. . . . . . . B.A.# # # # h+. . . . . . . i+# # # ,+j+. . . . . . . < # # # # # # # # # # # # k+. . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . l+# # # # # # # # # # # # m+. . . . . . . n+# # # # 0 . . . . . . . z.# # # # v . . . . . . . . < # # # ++. . . . . . . h.3 # # # # # # # # # # # # o+. . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . m # # # # # # # # # # # p+. . . . . . . . I # # # { . . . . . . . . !.# # # # 1 . . . . . . . h.3 # # # <+. . . . . . . H.# # # # # # # # # # # # # c . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . v.# # # # # # # # # # q+. . . . . . . + d # # # r+. . . . . . . s+h # # # e t . . . . . . . g # # # ' d+. . . . . . . t+# # # # # # # # # # # # # G . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . u+# # # # # # # # # # v+. . . . . . . C # # # # w+. . . . . . . x+# # # # p . . . . . . . . t+# # # y+. . . . . . . :+e # # # # # # # # # # # # # z+. . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . ] # # # # # # # # # A+. . . . . . . . B+# # # 3.. . . . . . . . _ # # # # g . . . . . . . C+u # # # 0.. . . . . . . F # # # # # # # # # # # # # k+. . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . D+e # # # # # # # # E+. . . . . . . F+A.# # # G+. . . . . . . $+# # # # 3 2 . . . . . . . A # # # D.. . . . . . . . i # # # # # # # # # # # # # q+. . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . C.# # # # # # # # H+. . . . . . . | # # # h ^.. . . . . . . r+# # # # < . . . . . . . . 7 .+.+.+Q.. . . . . . . > # # # # # # # # # # # # # # I+. . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . -+# # # # # # # C.. . . . . . . . 9.# # # !.. . . . . . . . { # # # # / . . . . . . . . . . . . . . . . . . . . L # # # # # # # # # # # # # - . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . J+=.# # # # # # W . . . . . . . K+h # # # | . . . . . . . e.# # # # J K . . . . . . . . . . . . . . . . . . . L+M+# # # # # # # # # # # # # N+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . Y # # # # # M O+. . . . . . . G+# # # A.B.. . . . . . . 8.# # # # 0+. . . . . . . . . . . . . . . . . . . . N.# # # # # # # # # # # # # 3 T.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . >.h # # # # J.h h h h h h h h e # # # J.h h h h h h h h e # # # # & . . . . . . . . . . . . . . . . . . P+Q+# # # # # # # # # # # # # # i.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . q # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # X . . . . . . . . r+>+>+>+>+>+>+>+>+>+=.# # # # # # # # # # # # # # # o :+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . R+3 # # # # # # # # # # # # # # # # # # # # # # # # # # # # # ` . . . . . . . V ].# # # # # # # # # # # # # # # # # # # # # # # # # S+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . &.# # # # # # # # # # # # # # # # # # # # # # # # # # # # # T+. . . . . . . U+# # # # # # # # # # # # # # # # # # # # # # # # # D.z . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . V+{ # # # # # # # # # # # # # # # # # # # # # # # # # # # >+. . . . . . . . !+# # # # # # # # # # # # # # # # # # # # # # # # # / . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . [ M # # # # # # # # # # # # # # # # # # # # # # # # # # &.. . . . . . . W+=.# # # # # # # # # # # # # # # # # # # # # # # # +.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 7 # # # # # # # # # # # # # # # # # # # # # # # # # # $+. . . . . . . #+# # # # # # # # # # # # # # # # # # # # # # # # - E . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 6+# # # # # # # # # # # # # # # # # # # # # # # # X+. . . . . . . . Y+# # # # # # # # # # # # # # # # # # # # # # # A.Z+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . `+: # # # # # # # # # # # # # # # # # # # # # # #  @. . . . . . . c.M # # # # # # # # # # # # # # # # # # # # # # M .@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +@>+# # # # # # # # # # # # # # # # # # # # # /.^.. . . . . . . s # # # # # # # # # # # # # # # # # # # # # # b.@@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . l.k+# # # # # # # # # # # # # # # # # # # # !.. . . . . . . . X+# # # # # # # # # # # # # # # # # # # # # M #@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .  .d.# # # # # # # # # # # # # # # # # # # $@. . . . . . . %@# # # # # # # # # # # # # # # # # # # # # A..@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . &@*@# # # # # # # # # # # # # # # # # =.=@. . . . . . . &.# # # # # # # # # # # # # # # # # # # # - -@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ;@>@# # # # # # # # # # # # # # # #.. . . . . . . . @.# # # # # # # # # # # # # # # # # # # y+,@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . '@^+# # # # # # # # # # # # # # k . . . . . . . )@# # # # # # # # # # # # # # # # # # v.C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . @@/+# # # # # # # # # # # d [+. . . . . . . S+# # # # # # # # # # # # # # # # =.E+=@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . !@W { # # # # # # # # # Y . . . . . . . . X # # # # # # # # # # # # # # M+E+ .. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . F.#.=.# # # # # # T . . . . . . . S # # # # # # # # # # # # =.6+G a . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ~@{@(.# # # P . . . . . . . . ; # # # # # # # J.M.(.]@9+8+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
"  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . Y+# # # ) . . . . . . . ! ~ # # # d.^@/@(@V . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
"  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . t u # # # _@. . . . . . . G # # # # :@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
"    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . N+# # # i . . . . . . . . o+# # # h :.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .     ",
"      . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . <@# # # 1 . . . . . . . z 3 # # # 9.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .       ",
"        . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 6.# # # u C+. . . . . . . [@# # # # }@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .         ",
"            . . . . . . . . V + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + i.# # # t+V V V V V V V V  +# # # 3 z + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + V . . . . . . .             ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                "};
/* XPM */
const char * HP_16_xpm[] = {
"16 16 41 1",
" 	c None",
".	c #000080",
"+	c #505090",
"@	c #C1C1D1",
"#	c #7C7CA4",
"$	c #D6D6E0",
"%	c #6F6F9E",
"&	c #8686AA",
"*	c #FAFAFB",
"=	c #AAAAC0",
"-	c #BFBFCF",
";	c #FFFFFF",
">	c #E7E7ED",
",	c #616197",
"'	c #FBFBFC",
")	c #4B4B8F",
"!	c #F1F1F4",
"~	c #EDEDF1",
"{	c #383888",
"]	c #D7D7E0",
"^	c #BBBBCD",
"/	c #A9A9C0",
"(	c #DBDBE4",
"_	c #9999B6",
":	c #CFCFDB",
"<	c #9090B0",
"[	c #DCDCE4",
"}	c #CBCBD8",
"|	c #D5D5DF",
"1	c #F7F7F9",
"2	c #45458D",
"3	c #C2C2D1",
"4	c #B1B1C5",
"5	c #DDDDE5",
"6	c #AFAFC4",
"7	c #AAAAC1",
"8	c #9E9EBA",
"9	c #ECECF0",
"0	c #393988",
"a	c #7C7CA5",
"b	c #E2E2E9",
"                ",
"                ",
"                ",
".....+@#$%......",
"....&*=-;;>,....",
"...+*')!;;;~{...",
"...-;]%+>{#^/...",
"...(;_-{:<<[}...",
"...|12-_<3+;}...",
"...4546$.#7;8...",
"...{!;;}_;;90...",
"....,9;a(;b,....",
"......}+}%......",
"                ",
"                ",
"                "};
/* XPM */
const char * HP_32_xpm[] = {
"32 32 92 2",
"  	c None",
". 	c #000080",
"+ 	c #B1B1C5",
"@ 	c #D7D7E1",
"# 	c #7B7BA4",
"$ 	c #FAFAFB",
"% 	c #383888",
"& 	c #9999B6",
"* 	c #F1F1F4",
"= 	c #9797B5",
"- 	c #BFBFCF",
"; 	c #F6F6F8",
"> 	c #CBCBD8",
", 	c #9090B0",
"' 	c #616197",
") 	c #DEDEE6",
"! 	c #FFFFFF",
"~ 	c #191983",
"{ 	c #F3F3F6",
"] 	c #ECECF0",
"^ 	c #9898B5",
"/ 	c #8F8FB0",
"( 	c #C1C1D1",
"_ 	c #E7E7ED",
": 	c #8B8BAE",
"< 	c #ADADC3",
"[ 	c #B0B0C5",
"} 	c #F1F1F5",
"| 	c #2C2C86",
"1 	c #F7F7F8",
"2 	c #66669A",
"3 	c #EEEEF2",
"4 	c #505090",
"5 	c #E4E4EB",
"6 	c #7474A1",
"7 	c #7777A3",
"8 	c #C9C9D7",
"9 	c #6F6F9E",
"0 	c #7A7AA4",
"a 	c #C5C5D3",
"b 	c #9090B1",
"c 	c #B9B9CB",
"d 	c #4A4A8E",
"e 	c #E3E3EA",
"f 	c #303087",
"g 	c #F2F2F5",
"h 	c #A3A3BC",
"i 	c #E9E9EE",
"j 	c #42428C",
"k 	c #FBFBFC",
"l 	c #B8B8CA",
"m 	c #AAAAC0",
"n 	c #8484AA",
"o 	c #A9A9C0",
"p 	c #DCDCE4",
"q 	c #6E6E9E",
"r 	c #5E5E96",
"s 	c #DDDDE5",
"t 	c #7C7CA4",
"u 	c #9A9AB7",
"v 	c #575793",
"w 	c #F8F8FA",
"x 	c #363688",
"y 	c #9191B1",
"z 	c #DFDFE7",
"A 	c #535392",
"B 	c #CCCCD8",
"C 	c #9292B2",
"D 	c #6E6E9D",
"E 	c #4D4D8F",
"F 	c #B7B7CA",
"G 	c #D3D3DE",
"H 	c #8181A8",
"I 	c #FDFDFE",
"J 	c #DFDFE8",
"K 	c #8D8DAF",
"L 	c #D6D6E0",
"M 	c #F5F5F8",
"N 	c #B1B1C6",
"O 	c #D1D1DC",
"P 	c #67679A",
"Q 	c #C5C5D4",
"R 	c #7676A2",
"S 	c #BEBECE",
"T 	c #393988",
"U 	c #A2A2BB",
"V 	c #CCCCD9",
"W 	c #8080A8",
"X 	c #7F7FA7",
"Y 	c #D2D2DC",
"Z 	c #BCBCCD",
"` 	c #C2C2D2",
"                                                                ",
"                                                                ",
"                                                                ",
"                                                                ",
"                                                                ",
"                                                                ",
"  . . . . . . . . . . . + @ . # $ % . . . . . . . . . . . . .   ",
". . . . . . . . . . . & * = . - ; > - , . . . . . . . . . . . . ",
". . . . . . . . . ' ) ! ; ~ . { ! ! ! ! ] ^ . . . . . . . . . . ",
". . . . . . . . ' * ! ! > . / ! ! ! ! ! ! ! ( . . . . . . . . . ",
". . . . . . . . _ ! ! ! : . > ! ! ! ! ! ! ! ! < . . . . . . . . ",
". . . . . . . [ ! ! ! } . | 1 ! ! ! ! ! ! ! ! $ 2 . . . . . . . ",
". . . . . . . 3 ! ! ! - . . . 4 5 ! 6 . . . 7 $ 8 . . . . . . . ",
". . . . . . 9 ! ! ! ! 0 . a b . c _ . d e f . g ; . . . . . . . ",
". . . . . . h ! ! ! i . j k 4 . _ l . m @ . n ! ! 9 . . . . . . ",
". . . . . . m ! ! ! l . o p . q ! r . s & . > ! ! t . . . . . . ",
". . . . . . m ! ! ! ' . s u . - ) . v w x . ; ! ! t . . . . . . ",
". . . . . . y ! ! z . A $ % . * m . l B . C ! ! ! D . . . . . . ",
". . . . . . E ! ! m . F G . H I 4 . J K . L ! ! M . . . . . . . ",
". . . . . . . @ ! , t _ N t O @ . . . . P $ ! ! Q . . . . . . . ",
". . . . . . . R ! ! ! ! ! ! ! & . - ! ! ! ! ! $ 4 . . . . . . . ",
". . . . . . . . S ! ! ! ! ! $ T . * ! ! ! ! ! U . . . . . . . . ",
". . . . . . . . . > ! ! ! ! V . W ! ! ! ! ! m . . . . . . . . . ",
". . . . . . . . . . & * ! ! , . > ! ! ! _ X . . . . . . . . . . ",
". . . . . . . . . . . . m ; . . ; Y < # . . . . . . . . . . . . ",
"  . . . . . . . . . . . Z ` . C * . . . . . . . . . . . . . .   ",
"                                                                ",
"                                                                ",
"                                                                ",
"                                                                ",
"                                                                ",
"                                                                "};
/* XPM */
const char * HP_48_xpm[] = {
"48 48 146 2",
"  	c None",
". 	c #000080",
"+ 	c #505090",
"@ 	c #FDFDFE",
"# 	c #CACAD7",
"$ 	c #7C7CA4",
"% 	c #FFFFFF",
"& 	c #C6C6D4",
"* 	c #B3B3C7",
"= 	c #8383A9",
"- 	c #C0C0D0",
"; 	c #8E8EAF",
"> 	c #616198",
", 	c #C7C7D6",
"' 	c #F7F7FA",
") 	c #F1F1F4",
"! 	c #F4F4F7",
"~ 	c #F9F9FB",
"{ 	c #E7E7ED",
"] 	c #D0D0DB",
"^ 	c #9999B6",
"/ 	c #2E2E86",
"( 	c #B9B9CB",
"_ 	c #FAFAFC",
": 	c #BFBFCF",
"< 	c #8F8FB0",
"[ 	c #F6F6F8",
"} 	c #AFAFC5",
"| 	c #383888",
"1 	c #DCDCE5",
"2 	c #6E6E9E",
"3 	c #CCCCD9",
"4 	c #E4E4EA",
"5 	c #616197",
"6 	c #0E0E81",
"7 	c #E1E1E8",
"8 	c #2F2F87",
"9 	c #F8F8F9",
"0 	c #B7B7C9",
"a 	c #48488E",
"b 	c #7C7CA5",
"c 	c #595994",
"d 	c #D7D7E1",
"e 	c #D8D8E1",
"f 	c #E2E2E9",
"g 	c #DDDDE5",
"h 	c #4A4A8E",
"i 	c #FBFBFC",
"j 	c #8C8CAE",
"k 	c #7878A3",
"l 	c #A9A9C0",
"m 	c #2D2D86",
"n 	c #66669A",
"o 	c #8181A8",
"p 	c #9A9AB7",
"q 	c #7A7AA4",
"r 	c #E3E3EA",
"s 	c #FCFCFD",
"t 	c #46468D",
"u 	c #71719F",
"v 	c #6F6F9E",
"w 	c #8787AB",
"x 	c #FAFAFB",
"y 	c #393988",
"z 	c #7B7BA4",
"A 	c #626298",
"B 	c #9191B2",
"C 	c #6B6B9D",
"D 	c #565693",
"E 	c #9191B1",
"F 	c #D1D1DD",
"G 	c #B8B8CA",
"H 	c #B0B0C5",
"I 	c #B7B7CA",
"J 	c #7979A3",
"K 	c #CECEDA",
"L 	c #BBBBCD",
"M 	c #5D5D96",
"N 	c #E0E0E8",
"O 	c #F7F7F9",
"P 	c #353587",
"Q 	c #E9E9EF",
"R 	c #F0F0F3",
"S 	c #E0E0E7",
"T 	c #5F5F96",
"U 	c #9A9AB6",
"V 	c #AAAAC0",
"W 	c #F2F2F6",
"X 	c #7D7DA6",
"Y 	c #C4C4D3",
"Z 	c #4F4F90",
"` 	c #E8E8EE",
" .	c #F0F0F4",
"..	c #161683",
"+.	c #4E4E8F",
"@.	c #F5F5F7",
"#.	c #D9D9E2",
"$.	c #7575A1",
"%.	c #8282A9",
"&.	c #AAAAC1",
"*.	c #BDBDCE",
"=.	c #9090B0",
"-.	c #D6D6E0",
";.	c #D4D4DF",
">.	c #FEFEFE",
",.	c #DFDFE7",
"'.	c #67679A",
").	c #F1F1F5",
"!.	c #B2B2C7",
"~.	c #EDEDF1",
"{.	c #040481",
"].	c #5E5E96",
"^.	c #9F9FBA",
"/.	c #9595B4",
"(.	c #8888AC",
"_.	c #1C1C83",
":.	c #C1C1D1",
"<.	c #D2D2DD",
"[.	c #D1D1DC",
"}.	c #B4B4C8",
"|.	c #DFDFE6",
"1.	c #AFAFC4",
"2.	c #525291",
"3.	c #8484A9",
"4.	c #4C4C8F",
"5.	c #CBCBD8",
"6.	c #A7A7BF",
"7.	c #E6E6EC",
"8.	c #8686AA",
"9.	c #43438C",
"0.	c #DEDEE6",
"a.	c #EBEBF0",
"b.	c #646499",
"c.	c #D7D7E0",
"d.	c #363688",
"e.	c #B2B2C6",
"f.	c #9898B5",
"g.	c #373788",
"h.	c #252585",
"i.	c #E8E8ED",
"j.	c #DADAE3",
"k.	c #353588",
"l.	c #7474A1",
"m.	c #C8C8D6",
"n.	c #9C9CB8",
"o.	c #8383AA",
"                                                                                                ",
"                                                                                                ",
"                                                                                                ",
"                                                                                                ",
"                                                                                                ",
"                                                                                                ",
"                                                                                                ",
"                                                                                                ",
"                                                                                                ",
"  . . . . . . . . . . . . . . . . . + @ # . . $ % & . . . . . . . . . . . . . . . . . . . . .   ",
". . . . . . . . . . . . . . . . . . * % = . . - % ; . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . > , ' ) . . . ! % % ~ { ] ^ / . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . ( _ % % : . . < % % % % % % % [ } . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . | 1 % % % % 2 . . 3 % % % % % % % % % 4 5 . . . . . . . . . . . . . . ",
". . . . . . . . . . . . 6 7 % % % % { . . 8 9 % % % % % % % % % % ) 5 . . . . . . . . . . . . . ",
". . . . . . . . . . . . - % % % % % 0 . . ^ % % % % % % % % % % % % ) a . . . . . . . . . . . . ",
". . . . . . . . . . . b % % % % % % c . . d % % % % % % % % % % % % % e . . . . . . . . . . . . ",
". . . . . . . . . . . f % % % % % g . . h i % % % % % % % % % % % % % % j . . . . . . . . . . . ",
". . . . . . . . . . k % % % % % % l . . m n n o f % % p . . . . . q 4 % r . . . . . . . . . . . ",
". . . . . . . . . . : % % % % % s t . . u v . . w % x y . . z A . . B % % C . . . . . . . . . . ",
". . . . . . . . . . { % % % % % d . . D % : . . E % F . . A % G . . H % % G . . . . . . . . . . ",
". . . . . . . . . . % % % % % % ^ . . I % J . . K % E . . L % M . . N % % e . . . . . . . . . . ",
". . . . . . . . . A % % % % % O P . . { Q . . y ~ [ . . . R S . . T % % % { . . . . . . . . . . ",
". . . . . . . . . $ % % % % % 3 . . 2 % G . . U % , . . b % V . . G % % % W . . . . . . . . . . ",
". . . . . . . . . k % % % % % < . . : % T . . e % X . . Y @ Z . . ` % % %  .. . . . . . . . . . ",
". . . . . . . . . ..% % % % ! . . . ) 7 . . +.@ ) . . . @.#.. . $.% % % % { . . . . . . . . . . ",
". . . . . . . . . . ) % % % - . . %.% &.. . V % *.. . =.% U . . : % % % % -.. . . . . . . . . . ",
". . . . . . . . . . ;.% % % z . . # >.+ . . ,.% '.. . K x y . . ).% % % % !.. . . . . . . . . . ",
". . . . . . . . . . ^ % % ~.. . {.[ #.. . ].% { . . . ^./.. . (.% % % % % 5 . . . . . . . . . . ",
". . . . . . . . . . _.[ % g V V :.% <.V V [.% }.. . . . . . + f % % % % |.. . . . . . . . . . . ",
". . . . . . . . . . . 1.% % % % % % % % % % % 2.. . e % % % % % % % % % 3.. . . . . . . . . . . ",
". . . . . . . . . . . . { % % % % % % % % % g . . 4.@ % % % % % % % % 5.. . . . . . . . . . . . ",
". . . . . . . . . . . . 5 O % % % % % % % % 6.. . V % % % % % % % % 7.| . . . . . . . . . . . . ",
". . . . . . . . . . . . . 8.x % % % % % % i 9.. . 0.% % % % % % % a.].. . . . . . . . . . . . . ",
". . . . . . . . . . . . . . b.a.% % % % % c.. . M % % % % % % % d | . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . d.e.[ % % % ^ . . G % % % % % a.f.. . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . g.^  .O h.. . i.x { j.*.b . . . . . . . . . . . . . . . . . . ",
"  . . . . . . . . . . . . . . . . . k.O 5.. . l.% m.. . . . . . . . . . . . . . . . . . . . .   ",
"  . . . . . . . . . . . . . . . . . n.% ; . . : % o.. . . . . . . . . . . . . . . . . . . . .   ",
"                                                                                                ",
"                                                                                                ",
"                                                                                                ",
"                                                                                                ",
"                                                                                                ",
"                                                                                                ",
"                                                                                                ",
"                                                                                                ",
"                                                                                                "};
/* XPM */
const char * HP_64_xpm[] = {
"64 64 196 2",
"  	c None",
". 	c #000080",
"+ 	c #D7D7E0",
"@ 	c #FFFFFF",
"# 	c #BDBDCE",
"$ 	c #7B7BA4",
"% 	c #636399",
"& 	c #505090",
"* 	c #FEFEFE",
"= 	c #68689B",
"- 	c #C1C1D1",
"; 	c #EAEAEF",
"> 	c #E7E7ED",
", 	c #F4F4F7",
"' 	c #D0D0DB",
") 	c #7C7CA4",
"! 	c #606097",
"~ 	c #080881",
"{ 	c #A6A6BF",
"] 	c #ECECF1",
"^ 	c #B3B3C8",
"/ 	c #8F8FB0",
"( 	c #F7F7F9",
"_ 	c #DADAE3",
": 	c #A5A5BE",
"< 	c #3A3A89",
"[ 	c #ECECF0",
"} 	c #535392",
"| 	c #CCCCD9",
"1 	c #F8F8FA",
"2 	c #BEBECF",
"3 	c #393989",
"4 	c #ABABC2",
"5 	c #FCFCFD",
"6 	c #DDDDE5",
"7 	c #323287",
"8 	c #F2F2F5",
"9 	c #9090B0",
"0 	c #C6C6D5",
"a 	c #9999B6",
"b 	c #B6B6CA",
"c 	c #B1B1C7",
"d 	c #FBFBFC",
"e 	c #3F3F8B",
"f 	c #D8D8E1",
"g 	c #CBCBD8",
"h 	c #4A4A8E",
"i 	c #B1B1C6",
"j 	c #41418C",
"k 	c #F4F4F6",
"l 	c #9797B5",
"m 	c #A9A9C0",
"n 	c #8585AB",
"o 	c #C5C5D4",
"p 	c #F6F6F8",
"q 	c #1E1E84",
"r 	c #DEDEE7",
"s 	c #EFEFF3",
"t 	c #383888",
"u 	c #515191",
"v 	c #5B5B95",
"w 	c #B2B2C7",
"x 	c #BFBFCF",
"y 	c #8989AD",
"z 	c #4F4F90",
"A 	c #7C7CA5",
"B 	c #EBEBF0",
"C 	c #040480",
"D 	c #060681",
"E 	c #8080A7",
"F 	c #D6D6E0",
"G 	c #393988",
"H 	c #6D6D9D",
"I 	c #6E6E9F",
"J 	c #020280",
"K 	c #F1F1F4",
"L 	c #7878A3",
"M 	c #C7C7D6",
"N 	c #5D5D96",
"O 	c #E1E1E8",
"P 	c #DCDCE5",
"Q 	c #7575A2",
"R 	c #D5D5DF",
"S 	c #555593",
"T 	c #B6B6C9",
"U 	c #8D8DAF",
"V 	c #F3F3F6",
"W 	c #0C0C81",
"X 	c #252584",
"Y 	c #CDCDD9",
"Z 	c #E9E9EF",
"` 	c #9595B3",
" .	c #575794",
"..	c #CCCCD8",
"+.	c #C0C0D0",
"@.	c #9292B2",
"#.	c #E7E7EC",
"$.	c #B8B8CA",
"%.	c #8787AB",
"&.	c #181882",
"*.	c #DDDDE6",
"=.	c #282885",
"-.	c #7A7AA4",
";.	c #D1D1DD",
">.	c #5C5C96",
",.	c #CACAD7",
"'.	c #67679B",
").	c #9898B5",
"!.	c #EBEBF1",
"~.	c #373788",
"{.	c #FAFAFB",
"].	c #B5B5C9",
"^.	c #E0E0E8",
"/.	c #8686AB",
"(.	c #47478D",
"_.	c #D7D7E1",
":.	c #B9B9CB",
"<.	c #9B9BB7",
"[.	c #AAAAC1",
"}.	c #42428C",
"|.	c #616197",
"1.	c #D9D9E2",
"2.	c #FDFDFE",
"3.	c #4C4C8F",
"4.	c #7F7FA7",
"5.	c #A7A7BF",
"6.	c #E3E3EA",
"7.	c #4E4E8F",
"8.	c #D2D2DD",
"9.	c #3C3C8A",
"0.	c #7474A1",
"a.	c #C8C8D6",
"b.	c #2F2F87",
"c.	c #B7B7CA",
"d.	c #9A9AB7",
"e.	c #A1A1BC",
"f.	c #E9E9EE",
"g.	c #030381",
"h.	c #545492",
"i.	c #FEFEFF",
"j.	c #E1E1E9",
"k.	c #7777A2",
"l.	c #8A8AAD",
"m.	c #F9F9FB",
"n.	c #353588",
"o.	c #DCDCE4",
"p.	c #9292B1",
"q.	c #8E8EB0",
"r.	c #B3B3C7",
"s.	c #5F5F96",
"t.	c #515190",
"u.	c #5D5D95",
"v.	c #9292B3",
"w.	c #C9C9D7",
"x.	c #9090B1",
"y.	c #AEAEC4",
"z.	c #DFDFE7",
"A.	c #C2C2D1",
"B.	c #6F6F9E",
"C.	c #AAAAC2",
"D.	c #F0F0F4",
"E.	c #D1D1DC",
"F.	c #EDEDF2",
"G.	c #F6F6F9",
"H.	c #F7F7FA",
"I.	c #5F5F97",
"J.	c #BABACC",
"K.	c #7E7EA6",
"L.	c #626298",
"M.	c #C6C6D4",
"N.	c #E5E5EB",
"O.	c #F5F5F7",
"P.	c #9C9CB8",
"Q.	c #101082",
"R.	c #D3D3DF",
"S.	c #9191B1",
"T.	c #AAAAC0",
"U.	c #090981",
"V.	c #D0D0DC",
"W.	c #9E9EB9",
"X.	c #E5E5EC",
"Y.	c #A1A1BB",
"Z.	c #A2A2BB",
"`.	c #A8A8BF",
" +	c #DEDEE6",
".+	c #FAFAFC",
"++	c #3B3B89",
"@+	c #E4E4EB",
"#+	c #8282A8",
"$+	c #B0B0C5",
"%+	c #4D4D8F",
"&+	c #9898B7",
"*+	c #171782",
"=+	c #E8E8ED",
"-+	c #010180",
";+	c #141482",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"    . . . . . . . . . . . . . . . . . . . . . . . + @ # . . . $ @ @ % . . . . . . . . . . . . . . . . . . . . . . . . . . .     ",
"  . . . . . . . . . . . . . . . . . . . . . . . & * @ = . . . - @ ; . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
". . . . . . . . . . . . . . . . . . . . . . . . # @ > . . . . , @ ' $ ) ! . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . ~ { ] @ @ ^ . . . / @ @ @ @ @ @ ( _ : < . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . $ [ @ @ @ @ } . . . | @ @ @ @ @ @ @ @ @ 1 2 3 . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . 4 5 @ @ @ @ 6 . . . 7 1 @ @ @ @ @ @ @ @ @ @ @ 8 9 . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . 0 @ @ @ @ @ @ { . . . a @ @ @ @ @ @ @ @ @ @ @ @ @ @ b . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . c @ @ @ @ @ @ d e . . . f @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ g . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . 9 @ @ @ @ @ @ @ + . . . h 5 @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ i . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . j k @ @ @ @ @ @ @ l . . . m @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ n . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . o @ @ @ @ @ @ @ p q . . . r @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ s t . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . u d @ @ @ @ @ @ @ g . . . v @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ w . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . x @ @ @ @ @ @ @ @ y . . . z A A ) 9 B @ @ @ 2 C C C C C C D E F @ @ p G . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . 8 @ @ @ @ @ @ @ 8 . . . . . . . . . H @ @ @ I . . . . . . . . J K @ @ : . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . L @ @ @ @ @ @ @ @ x . . . H g o . . . . @ @ > . . . . M g N . . . O @ @ P . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . i @ @ @ @ @ @ @ @ Q . . . x @ R . . . S @ @ T . . . U @ V . . . W p @ @ 5 X . . . . . . . . . . . . . ",
". . . . . . . . . . . . . Y @ @ @ @ @ @ @ Z . . . . 8 @ ` . . . ^ @ @  .. . . ..@ +.. . . @.@ @ @ @ E . . . . . . . . . . . . . ",
". . . . . . . . . . . . . #.@ @ @ @ @ @ @ $.. . . %.@ p &.. . . > @ *.. . . =.( @ -.. . . ;.@ @ @ @ m . . . . . . . . . . . . . ",
". . . . . . . . . . . . . > @ @ @ @ @ @ @ >.. . . ,.@ ,.. . . '.@ @ m . . . ).@ !.. . . ~.{.@ @ @ @ ].. . . . . . . . . . . . . ",
". . . . . . . . . . . . . Z @ @ @ @ @ @ ^.. . . &.p @ /.. . . # @ 5 (.. . . _.@ :.. . . <.@ @ @ @ @ g . . . . . . . . . . . . . ",
". . . . . . . . . . . . . > @ @ @ @ @ @ [.. . . ` @ 8 . . . . K @ _.. . . }.d @ |.. . . 1.@ @ @ @ @ ,.. . . . . . . . . . . . . ",
". . . . . . . . . . . . . > @ @ @ @ @ 2.3.. . . R @ x . . . 4.@ @ a . . . 5.@ 6.. . . 7.2.@ @ @ @ @ i . . . . . . . . . . . . . ",
". . . . . . . . . . . . . 8.@ @ @ @ @ 1.. . . 9.d @ 0.. . . a.@ 1 b.. . . 6 @ 4 . . . [.@ @ @ @ @ @ 5.. . . . . . . . . . . . . ",
". . . . . . . . . . . . . c.@ @ @ @ @ d.. . . e.@ f.. . . g.p @ Y . . . h.@ i.& . . . j.@ @ @ @ @ @ k.. . . . . . . . . . . . . ",
". . . . . . . . . . . . . l.@ @ @ @ m.n.. . . o.@ c.. . . p.@ @ q.. . . r.@ _ . . . s.@ @ @ @ @ @ m.. . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . p @ @ @ ' . . . t.@ @ u.. . . 8.@ , . . . . g > v.. . . $.@ @ @ @ @ @ _.. . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . w.@ @ @ x.. . . y.@ z.. . . t {.@ A.. . . . . . . . . . ] @ @ @ @ @ @ ).. . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . B.@ @ i.C.C.C.C.B @ _.C.C.C.0 @ @ $ . . . . . . . . 3 w.@ @ @ @ @ @ D.. . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . E.@ @ @ @ @ @ @ @ @ @ @ @ @ @ F.. . . . Z G.G.G.H.@ @ @ @ @ @ @ @ : . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . I.{.@ @ @ @ @ @ @ @ @ @ @ @ @ J.. . . K.@ @ @ @ @ @ @ @ @ @ @ @ > . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . : @ @ @ @ @ @ @ @ @ @ @ @ @ L.. . . M.@ @ @ @ @ @ @ @ @ @ @ {.B.. . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . g @ @ @ @ @ @ @ @ @ @ @ N.. . . J O.@ @ @ @ @ @ @ @ @ @ @ P.. . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . Q.R.@ @ @ @ @ @ @ @ @ @ y.. . . S.@ @ @ @ @ @ @ @ @ @ @ T.. . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . U.,.@ @ @ @ @ @ @ @ @ & . . . V.@ @ @ @ @ @ @ @ @ {.P.. . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . W.( @ @ @ @ @ @ o.. . . ~.m.@ @ @ @ @ @ @ @ X.H . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . z o {.@ @ @ @ Y.. . . <.@ @ @ @ @ @ @ [ Z.. . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . }.`. +@ .+++. . . 1.@ @ @ 5 @++.#+. . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . $+@ R . . . %+2.@ &+*+. . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
"  . . . . . . . . . . . . . . . . . . . . . . . . =+@ ` . . . [.@ p -+. . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
"    . . . . . . . . . . . . . . . . . . . . . . L @ p ;+. . . ^.@ w.. . . . . . . . . . . . . . . . . . . . . . . . . . . .     ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                ",
"                                                                                                                                "};

/* XPM */
const char * HP_256_xpm[] = {
"256 256 419 2",
"  	c None",
". 	c #000080",
"+ 	c #101082",
"@ 	c #34348A",
"# 	c #36368B",
"$ 	c #67679F",
"% 	c #FEFEFE",
"& 	c #FFFFFF",
"* 	c #C9C9D8",
"= 	c #525293",
"- 	c #9A9ABA",
"; 	c #FCFCFD",
"> 	c #545496",
", 	c #33338A",
"' 	c #0D0D82",
") 	c #B5B5CA",
"! 	c #8181AA",
"~ 	c #DEDEE8",
"{ 	c #151582",
"] 	c #EEEEF3",
"^ 	c #0B0B81",
"/ 	c #252585",
"( 	c #F5F5F8",
"_ 	c #ACACC4",
": 	c #8989AF",
"< 	c #BDBDD0",
"[ 	c #9494B5",
"} 	c #5A5A97",
"| 	c #D2D2DE",
"1 	c #6E6EA0",
"2 	c #D2D2DF",
"3 	c #E4E4EC",
"4 	c #010180",
"5 	c #4C4C90",
"6 	c #FBFBFD",
"7 	c #E7E7EE",
"8 	c #3D3D8C",
"9 	c #FAFAFC",
"0 	c #B4B4C9",
"a 	c #AFAFC7",
"b 	c #B1B1C8",
"c 	c #A1A1BD",
"d 	c #69699E",
"e 	c #040481",
"f 	c #EAEAF0",
"g 	c #5A5A96",
"h 	c #DBDBE6",
"i 	c #E9E9F0",
"j 	c #040480",
"k 	c #8080A9",
"l 	c #DEDEE7",
"m 	c #535394",
"n 	c #FDFDFE",
"o 	c #BBBBCF",
"p 	c #CDCDDB",
"q 	c #A6A6C0",
"r 	c #AEAEC6",
"s 	c #7777A5",
"t 	c #41418D",
"u 	c #F9F9FB",
"v 	c #FBFBFC",
"w 	c #44448E",
"x 	c #E5E5EC",
"y 	c #2E2E87",
"z 	c #9898B8",
"A 	c #DDDDE7",
"B 	c #D5D5E1",
"C 	c #67679D",
"D 	c #FEFEFF",
"E 	c #EEEEF4",
"F 	c #F6F6FA",
"G 	c #F8F8FB",
"H 	c #F1F1F6",
"I 	c #EBEBF1",
"J 	c #E2E2EB",
"K 	c #D7D7E2",
"L 	c #C8C8D7",
"M 	c #B4B4CA",
"N 	c #6F6FA0",
"O 	c #2F2F88",
"P 	c #68689D",
"Q 	c #C3C3D4",
"R 	c #F6F6F9",
"S 	c #BABACE",
"T 	c #CACAD9",
"U 	c #A4A4BF",
"V 	c #64649B",
"W 	c #070781",
"X 	c #050581",
"Y 	c #8585AD",
"Z 	c #D9D9E4",
"` 	c #F7F7FA",
" .	c #2D2D87",
"..	c #ECECF2",
"+.	c #F0F0F5",
"@.	c #030380",
"#.	c #E1E1E9",
"$.	c #CCCCDA",
"%.	c #7B7BA7",
"&.	c #9393B4",
"*.	c #202085",
"=.	c #7676A4",
"-.	c #DDDDE6",
";.	c #8888AE",
">.	c #C5C5D5",
",.	c #F3F3F7",
"'.	c #BFBFD1",
").	c #62629A",
"!.	c #4E4E91",
"~.	c #CBCBDA",
"{.	c #161683",
"].	c #1B1B84",
"^.	c #D6D6E2",
"/.	c #8080AA",
"(.	c #0F0F82",
"_.	c #C1C1D3",
":.	c #8D8DB1",
"<.	c #DFDFE8",
"[.	c #8787AD",
"}.	c #5E5E98",
"|.	c #DCDCE6",
"1.	c #CECEDC",
"2.	c #7777A4",
"3.	c #020280",
"4.	c #9D9DBB",
"5.	c #333389",
"6.	c #F8F8FA",
"7.	c #515192",
"8.	c #343488",
"9.	c #B6B6CB",
"0.	c #9B9BB9",
"a.	c #F7F7F9",
"b.	c #A7A7C1",
"c.	c #D8D8E3",
"d.	c #63639A",
"e.	c #8686AD",
"f.	c #E2E2EA",
"g.	c #494990",
"h.	c #060681",
"i.	c #A0A0BD",
"j.	c #ABABC4",
"k.	c #A9A9C2",
"l.	c #D1D1DE",
"m.	c #3D3D8B",
"n.	c #B2B2C9",
"o.	c #4E4E92",
"p.	c #E1E1EA",
"q.	c #6E6E9F",
"r.	c #5E5E99",
"s.	c #9292B4",
"t.	c #020281",
"u.	c #9E9EBB",
"v.	c #ADADC5",
"w.	c #BEBED1",
"x.	c #38388A",
"y.	c #BFBFD2",
"z.	c #0E0E81",
"A.	c #B3B3CA",
"B.	c #D0D0DD",
"C.	c #7272A2",
"D.	c #A2A2BE",
"E.	c #9090B3",
"F.	c #C0C0D2",
"G.	c #CDCDDC",
"H.	c #181883",
"I.	c #8989AE",
"J.	c #F4F4F8",
"K.	c #222285",
"L.	c #121282",
"M.	c #67679C",
"N.	c #C6C6D6",
"O.	c #8585AC",
"P.	c #3B3B8B",
"Q.	c #7F7FA9",
"R.	c #B5B5CB",
"S.	c #0F0F81",
"T.	c #2A2A87",
"U.	c #A7A7C2",
"V.	c #9595B5",
"W.	c #7E7EA8",
"X.	c #6C6C9F",
"Y.	c #D4D4E0",
"Z.	c #F2F2F6",
"`.	c #545494",
" +	c #202084",
".+	c #E6E6ED",
"++	c #40408D",
"@+	c #B0B0C7",
"#+	c #A3A3BE",
"$+	c #6B6B9E",
"%+	c #585896",
"&+	c #8484AC",
"*+	c #080881",
"=+	c #565695",
"-+	c #EFEFF4",
";+	c #3E3E8C",
">+	c #9B9BBA",
",+	c #C8C8D8",
"'+	c #343489",
")+	c #42428D",
"!+	c #8484AB",
"~+	c #6A6A9E",
"{+	c #242485",
"]+	c #48488F",
"^+	c #9696B6",
"/+	c #BBBBCE",
"(+	c #0C0C82",
"_+	c #EDEDF3",
":+	c #4D4D91",
"<+	c #B8B8CC",
"[+	c #606099",
"}+	c #313188",
"|+	c #F1F1F5",
"1+	c #1A1A83",
"2+	c #232385",
"3+	c #F4F4F7",
"4+	c #A5A5C0",
"5+	c #C2C2D4",
"6+	c #C4C4D5",
"7+	c #CECEDB",
"8+	c #E0E0E9",
"9+	c #9696B5",
"0+	c #9E9EBA",
"a+	c #AFAFC6",
"b+	c #5F5F98",
"c+	c #7474A3",
"d+	c #262685",
"e+	c #8B8BB0",
"f+	c #131382",
"g+	c #7D7DA8",
"h+	c #9191B4",
"i+	c #45458E",
"j+	c #F6F6F8",
"k+	c #C1C1D2",
"l+	c #B1B1C7",
"m+	c #323288",
"n+	c #61619A",
"o+	c #7373A3",
"p+	c #141482",
"q+	c #DADAE5",
"r+	c #D3D3E0",
"s+	c #9393B5",
"t+	c #323289",
"u+	c #5F5F99",
"v+	c #252586",
"w+	c #39398A",
"x+	c #D9D9E3",
"y+	c #9C9CBA",
"z+	c #7676A5",
"A+	c #1F1F84",
"B+	c #E3E3EA",
"C+	c #AAAAC3",
"D+	c #6F6FA1",
"E+	c #9595B7",
"F+	c #9494B6",
"G+	c #1D1D84",
"H+	c #EAEAF1",
"I+	c #E3E3EB",
"J+	c #4C4C91",
"K+	c #333388",
"L+	c #CFCFDC",
"M+	c #7575A4",
"N+	c #BEBED0",
"O+	c #8F8FB2",
"P+	c #2B2B87",
"Q+	c #575795",
"R+	c #1B1B83",
"S+	c #353589",
"T+	c #E9E9EF",
"U+	c #CFCFDD",
"V+	c #A5A5BF",
"W+	c #37378A",
"X+	c #515193",
"Y+	c #5B5B97",
"Z+	c #9999B8",
"`+	c #9595B6",
" @	c #303088",
".@	c #1C1C84",
"+@	c #D4D4E1",
"@@	c #A6A6C1",
"#@	c #C7C7D7",
"$@	c #8787AE",
"%@	c #9898B7",
"&@	c #3F3F8C",
"*@	c #C2C2D3",
"=@	c #46468E",
"-@	c #282886",
";@	c #9F9FBC",
">@	c #F5F5F9",
",@	c #E5E5ED",
"'@	c #DBDBE5",
")@	c #9A9AB8",
"!@	c #9797B7",
"~@	c #8A8AAF",
"{@	c #191983",
"]@	c #555595",
"^@	c #2E2E88",
"/@	c #3E3E8E",
"(@	c #595996",
"_@	c #CCCCDB",
":@	c #7070A0",
"<@	c #5C5C98",
"[@	c #8484AD",
"}@	c #E6E6EE",
"|@	c #171783",
"1@	c #6D6DA0",
"2@	c #B7B7CC",
"3@	c #030381",
"4@	c #E8E8EF",
"5@	c #BCBCCF",
"6@	c #7979A6",
"7@	c #63639B",
"8@	c #7070A1",
"9@	c #F4F4F9",
"0@	c #0C0C81",
"a@	c #A9A9C3",
"b@	c #2C2C87",
"c@	c #66669C",
"d@	c #1C1C83",
"e@	c #2F2F8B",
"f@	c #B5B5C9",
"g@	c #65659C",
"h@	c #4F4F92",
"i@	c #8282AA",
"j@	c #464692",
"k@	c #B7B7CA",
"l@	c #292987",
"m@	c #565697",
"n@	c #B4B4C8",
"o@	c #262686",
"p@	c #AEAEC5",
"q@	c #505092",
"r@	c #1E1E84",
"s@	c #5A5A98",
"t@	c #4E4E94",
"u@	c #A0A0BC",
"v@	c #9E9EBC",
"w@	c #9191B3",
"x@	c #37378D",
"y@	c #DADAE4",
"z@	c #3A3A8B",
"A@	c #232386",
"B@	c #7E7EA9",
"C@	c #5F5F9A",
"D@	c #A8A8C2",
"E@	c #9D9DBA",
"F@	c #4A4A90",
"G@	c #47478F",
"H@	c #0A0A81",
"I@	c #4B4B90",
"J@	c #9A9AB9",
"K@	c #ABABC3",
"L@	c #65659B",
"M@	c #5D5D98",
"N@	c #B3B3C9",
"O@	c #B9B9CD",
"P@	c #7878A5",
"Q@	c #8C8CB0",
"R@	c #050580",
"S@	c #7171A2",
"T@	c #6A6A9F",
"U@	c #F0F0F4",
"V@	c #8383AB",
"W@	c #212184",
"X@	c #111182",
"Y@	c #9090B2",
"Z@	c #BABACD",
"`@	c #D6D6E1",
" #	c #111183",
".#	c #46468F",
"+#	c #0D0D81",
"@#	c #292986",
"##	c #D8D8E2",
"$#	c #B8B8CD",
"%#	c #40408C",
"&#	c #B2B2C8",
"*#	c #B7B7CB",
"=#	c #D3D3DF",
"-#	c #272786",
";#	c #090981",
">#	c #69699D",
",#	c #C5C5D6",
"'#	c #FAFAFB",
")#	c #8282AB",
"!#	c #090982",
"~#	c #00007F",
"{#	c #F0F0F6",
"]#	c #F2F2F7",
"^#	c #8E8EB2",
"/#	c #151583",
"(#	c #CBCBDB",
"_#	c #CFCFDE",
":#	c #D7D7E3",
"<#	c #141483",
"[#	c #EFEFF3",
"}#	c #A8A8C1",
"|#	c #FDFDFD",
"1#	c #7A7AA6",
"2#	c #7575A3",
"3#	c #616199",
"4#	c #B9B9CE",
"5#	c #ECECF1",
"6#	c #7C7CA7",
"7#	c #2A2A86",
"8#	c #5D5D97",
"9#	c #555594",
"0#	c #8B8BAF",
"a#	c #8B8BB1",
"b#	c #8383AA",
"c#	c #68689E",
"d#	c #4F4F91",
"e#	c #EDEDF2",
"f#	c #3C3C8B",
"g#	c #070780",
"h#	c #383888",
"i#	c #3D3D8A",
"j#	c #8989B0",
"k#	c #222286",
"l#	c #373788",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                          . . . . . . . . . . . . . . + @ # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # $ % & & & & & & & * = = = = = = = = = = = = = = = = - & & & & & & & & ; > # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # , ' . . . . . . . . . . . .                           ",
"                    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ) & & & & & & & & ! . . . . . . . . . . . . . . . . * & & & & & & & & ~ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .                     ",
"                . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . { ] & & & & & & & ] ^ . . . . . . . . . . . . . . . / ( & & & & & & & & _ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .                 ",
"              . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . : & & & & & & & & < . . . . . . . . . . . . . . . . [ & & & & & & & & % } . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .               ",
"            . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . | & & & & & & & & 1 . . . . . . . . . . . . . . . . 2 & & & & & & & & 3 4 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .             ",
"          . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 5 6 & & & & & & & 7 . . . . . . . . . . . . . . . . 8 9 & & & & & & & & 0 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .           ",
"        . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . a & & & & & & & & b . . . . . . . . . . . . . . . . c & & & & & & & & & d . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .         ",
"      . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . e f & & & & & & & % g . . . . . . . . . . . . . . . . h & & & & & & & & i j . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .       ",
"    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . k & & & & & & & & l . . . . . . . . . . . . . . . . m n & & & & & & & & o . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .     ",
"    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . p & & & & & & & & q . . . . . . . . . . . . . . . . r & & & & & & & & & s . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .     ",
"  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . t u & & & & & & & v w . . . . . . . . . . . . . . . . x & & & & & & & & ] e . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
"  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . y z A & & & & & & & & B . . . . . . . . . . . . . . . . C D & & & & & & & & u E F 6 % n G H I J K L M z N O . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
"  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . P Q R & & & & & & & & & & z . . . . . . . . . . . . . . . . S & & & & & & & & & & & & & & & & & & & & & & & & ; 7 T U V W . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
"  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . X Y Z % & & & & & & & & & & & `  .. . . . . . . . . . . . . . . e ..& & & & & & & & & & & & & & & & & & & & & & & & & & & & & +.* [ O . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . @.: #.& & & & & & & & & & & & & & $.. . . . . . . . . . . . . . . . %.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & u 2 &.*.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . =.-.& & & & & & & & & & & & & & & & ;.. . . . . . . . . . . . . . . . >.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ,.'.).. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . !.~.% & & & & & & & & & & & & & & & & H {.. . . . . . . . . . . . . . . ].,.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & n ^./.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . (.U R & & & & & & & & & & & & & & & & & & _.. . . . . . . . . . . . . . . . :.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & <.[.4 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . }.|.& & & & & & & & & & & & & & & & & & & & s . . . . . . . . . . . . . . . . 1.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & |.2.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 3.4.` & & & & & & & & & & & & & & & & & & & & f e . . . . . . . . . . . . . . . 5.6.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & n $.7.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 8.~.& & & & & & & & & & & & & & & & & & & & & & 9.. . . . . . . . . . . . . . . . 0.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & a.b.' . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ).7 & & & & & & & & & & & & & & & & & & & & & & D V . . . . . . . . . . . . . . . . c.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & <.d.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . e.( & & & & & & & & & & & & & & & & & & & & & & & f.. . . . . . . . . . . . . . . . g.6 & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & u U h.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . i.; & & & & & & & & & & & & & & & & & & & & & & & & j.. . . . . . . . . . . . . . . . k.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & l.m.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 3.n.D & & & & & & & & & & & & & & & & & & & & & & & & ; o.. . . . . . . . . . . . . . . . p.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & I q.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 3.< & & & & & & & & & & & & & & & & & & & & & & & & & & Z . . . . . . . . . . . . . . . . r.% & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 6.s.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . t._.& & & & & & & & & & & & & & & & & & & & & & & & & & & u.. . . . . . . . . . . . . . . . ) & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & n v.4 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 3.w.& & & & & & & & & & & & & & & & & & & & & & & & & & & u x.. . . . . . . . . . . . . . . 4 i & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & y.z.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . A.& & & & & & & & & & & & & & & & & & & & & & & & & & & & B.. . . . . . . . . . . . . . . . C.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & T {.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . D.D & & & & & & & & & & & & & & & & & & & & & & & & & & & & E.. . . . . . . . . . . . . . . . F.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & G.H.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . I.; & & & & & & & & & & & & & & & & & & & & & & & & & & & & J.K.. . . . . . . . . . . . . . . L.+.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & $.' . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . M.R & & & & & & & & & & & & & & & & & & & & & & & & & & & & & N.. . . . . . . . . . . . . . . . O.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & >.j . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . P.f & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & Q.. . . . . . . . . . . . . . . . T & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & R.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . e l.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ] S.. . . . . . . . . . . . . . . T.R & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & D u.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . U.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & o . . . . . . . . . . . . . . . . V.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & v W.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . X.9 & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & X.. . . . . . . . . . . . . . . . Y.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & Z.`.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .  +x & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & .+3.. . . . . . . . . . . . . . . ++9 & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & <. +. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 9.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & @+. . . . . . . . . . . . . . . . #+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & o . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . $+v & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & % %+. . . . . . . . . . . . . . . . A & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & n &+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . *+l & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & A . . . . . . . . . . . . . . . . =+n & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & -+;+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . >+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & U . . . . . . . . . . . . . . . . @+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ,+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . '++.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & v )+. . . . . . . . . . . . . . . . .+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & % !+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ) & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & Y.. . . . . . . . . . . . . . . . ~+D & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & f {+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ]+` & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ^+. . . . . . . . . . . . . . . . /+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & a . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . < & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & R  .. . . . . . . . . . . . . . . (+_+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ` :+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ]+6.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & T . . . . . . . . . . . . . . . . W.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & >.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . <+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & e.. . . . . . . . . . . . . . . . N.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 6 [+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . }+J.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & |+1+. . . . . . . . . . . . . . . 2+3+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ~.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 4+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & F.. . . . . . . . . . . . . . . . } 5+5+5+5+5+5+5+5+5+5+5+6+7+8+6.& & & & & & & & & & & & & & & & & & & & K 9+9+9+9+9+9+9+9+9+9+9+9+9+9+9+9+9+9+9+9+9+9+9+9+9+9+9+^+0+a+p |+& & & & & & & & & & & & & & & ; b+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . h.7 & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & c+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . d+e+Z & & & & & & & & & & & & & & & & & & e.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . f+&+Z & & & & & & & & & & & & & & 6+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . g+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & f *+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . h+( & & & & & & & & & & & & & & & +.+ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . s.( & & & & & & & & & & & & u i+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . T & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ) . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . N j+& & & & & & & & & & & & & & k+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ~+,.& & & & & & & & & & & & l+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . m+` & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & D n+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . h+& & & & & & & & & & & & & & o+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . O.% & & & & & & & & & & & _+p+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . z & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & p.4 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . q+& & & & & & & & & & & & i . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . B.& & & & & & & & & & & & : . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . r+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & k.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . s+& & & & & & & & & & & & 9.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ! & & & & & & & & & & & & B.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . '+u & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ; :+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . t+6 & & & & & & & & & & % u+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . v+v & & & & & & & & & & & u w+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . E.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & x+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . I & & & & & & & & & & p.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ..& & & & & & & & & & & & u.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ,+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & y+. . . . . . . . . . . . . . . . }.z+z+z+z+z+z+z+z+A+. . . . . . . . . . . . . . . B+& & & & & & & & & & C+. . . . . . . . . . . . . . . . D+E+E+E+E+E+E+E+F+G+. . . . . . . . . . . . . . . H+& & & & & & & & & & & & B . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 3._+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & u x.. . . . . . . . . . . . . . . W f & & & & & & & -+^ . . . . . . . . . . . . . . . I+& & & & & & & & & ; J+. . . . . . . . . . . . . . . . f.& & & & & & & .+. . . . . . . . . . . . . . . . R & & & & & & & & & & & & u K+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . n+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & L+. . . . . . . . . . . . . . . . M+& & & & & & & & N+. . . . . . . . . . . . . . . . ..& & & & & & & & & c.. . . . . . . . . . . . . . . . ).% & & & & & & & l+. . . . . . . . . . . . . . . m % & & & & & & & & & & & & & O+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . c & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & :.. . . . . . . . . . . . . . . . _.& & & & & & & & D+. . . . . . . . . . . . . . . P+v & & & & & & & & & 4.. . . . . . . . . . . . . . . . 9.& & & & & & & n Q+. . . . . . . . . . . . . . . 0.& & & & & & & & & & & & & & >.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ~.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 3+2+. . . . . . . . . . . . . . . R+H & & & & & & & 7 . . . . . . . . . . . . . . . . ! & & & & & & & & & G S+. . . . . . . . . . . . . . . 4 f & & & & & & & A . . . . . . . . . . . . . . . . | & & & & & & & & & & & & & & i . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 4 T+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & >.. . . . . . . . . . . . . . . . [.& & & & & & & & n.. . . . . . . . . . . . . . . . N+& & & & & & & & & U+. . . . . . . . . . . . . . . . M+& & & & & & & & V+. . . . . . . . . . . . . . . W+u & & & & & & & & & & & & & & D X+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . , n & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & g+. . . . . . . . . . . . . . . . ~.& & & & & & & % Y+. . . . . . . . . . . . . . . f+-+& & & & & & & & & O+. . . . . . . . . . . . . . . . _.& & & & & & & v )+. . . . . . . . . . . . . . . Z+& & & & & & & & & & & & & & & & `+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . k & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & _+(.. . . . . . . . . . . . . . .  @` & & & & & & & ~ . . . . . . . . . . . . . . . . ! & & & & & & & & & ,..@. . . . . . . . . . . . . . . L.|+& & & & & & & +@. . . . . . . . . . . . . . . . B & & & & & & & & & & & & & & & & F.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . q & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & S . . . . . . . . . . . . . . . . ^+& & & & & & & & @@. . . . . . . . . . . . . . . . #@& & & & & & & & & N.. . . . . . . . . . . . . . . . $@& & & & & & & & %@. . . . . . . . . . . . . . . &@9 & & & & & & & & & & & & & & & & l . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . *@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ~+. . . . . . . . . . . . . . . . B & & & & & & & 6 =@. . . . . . . . . . . . . . . -@( & & & & & & & & & W.. . . . . . . . . . . . . . . . ~.& & & & & & & R P+. . . . . . . . . . . . . . . ;@& & & & & & & & & & & & & & & & & >@X . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . Z & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ,@@.. . . . . . . . . . . . . . . w v & & & & & & & B . . . . . . . . . . . . . . . . E.& & & & & & & & & _+h.. . . . . . . . . . . . . . . T.R & & & & & & & ~.. . . . . . . . . . . . . . . . '@& & & & & & & & & & & & & & & & & & } . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . I & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & a+. . . . . . . . . . . . . . . . U & & & & & & & & )@. . . . . . . . . . . . . . . . | & & & & & & & & & o . . . . . . . . . . . . . . . . !@& & & & & & & & ;.. . . . . . . . . . . . . . . o.; & & & & & & & & & & & & & & & & & & ~@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . {@` & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & n ]@. . . . . . . . . . . . . . . . ~ & & & & & & & ` ^@. . . . . . . . . . . . . . . m.u & & & & & & & & & $+. . . . . . . . . . . . . . . . Y.& & & & & & & |+f+. . . . . . . . . . . . . . . k.& & & & & & & & & & & & & & & & & & & k.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . /@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & -.. . . . . . . . . . . . . . . . (@n & & & & & & & _@. . . . . . . . . . . . . . . . ;@& & & & & & & & & ,@. . . . . . . . . . . . . . . . t v & & & & & & & *@. . . . . . . . . . . . . . . . p.& & & & & & & & & & & & & & & & & & & *@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . :@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & D.. . . . . . . . . . . . . . . . l+& & & & & & & & ~@. . . . . . . . . . . . . . . . '@& & & & & & & & & @+. . . . . . . . . . . . . . . . U & & & & & & & & =.. . . . . . . . . . . . . . . <@% & & & & & & & & & & & & & & & & & & & Y.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . [@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 9 t . . . . . . . . . . . . . . . j }@& & & & & & & Z.|@. . . . . . . . . . . . . . . X+n & & & & & & & & n Q+. . . . . . . . . . . . . . . . A & & & & & & & f 4 . . . . . . . . . . . . . . . 0 & & & & & & & & & & & & & & & & & & & & f.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . )@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & Y.. . . . . . . . . . . . . . . . 1@& & & & & & & & *@. . . . . . . . . . . . . . . . _ & & & & & & & & & A . . . . . . . . . . . . . . . . =+n & & & & & & & 2@. . . . . . . . . . . . . . . 3@4@& & & & & & & & & & & & & & & & & & & & ] 4 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . D.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & [ . . . . . . . . . . . . . . . . 5@& & & & & & & & 6@. . . . . . . . . . . . . . . 3.I+& & & & & & & & & U . . . . . . . . . . . . . . . . @+& & & & & & & % 7@. . . . . . . . . . . . . . . 8@& & & & & & & & & & & & & & & & & & & & & 9@0@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . a@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & R b@. . . . . . . . . . . . . . . L.] & & & & & & & I X . . . . . . . . . . . . . . . c@D & & & & & & & & v t . . . . . . . . . . . . . . . . .+& & & & & & & f.. . . . . . . . . . . . . . . . N+& & & & & & & & & & & & & & & & & & & & & n d@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . @+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & T . . . . . . . . . . . . . . . . k & & & & & & & & 2@. . . . . . . . . . . . . . . . <+& & & & & & & & & Y.. . . . . . . . . . . . . . . . $+D & & & & & & & j.. . . . . . . . . . . . . . . L.-+& & & & & & & & & & & & & & & & & & & & & & e@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . f@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & &+. . . . . . . . . . . . . . . . N.& & & & & & & & g@. . . . . . . . . . . . . . . 0@I & & & & & & & & & !@. . . . . . . . . . . . . . . . 5@& & & & & & & ; h@. . . . . . . . . . . . . . . i@& & & & & & & & & & & & & & & & & & & & & & & j@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . k@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & +.{.. . . . . . . . . . . . . . . d+( & & & & & & & J . . . . . . . . . . . . . . . . 6@& & & & & & & & & R l@. . . . . . . . . . . . . . . h._+& & & & & & & Z . . . . . . . . . . . . . . . . L & & & & & & & & & & & & & & & & & & & & & & & m@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . n@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & '.. . . . . . . . . . . . . . . . E.& & & & & & & & _ . . . . . . . . . . . . . . . . Q & & & & & & & & & ~.. . . . . . . . . . . . . . . . W.& & & & & & & & ;@. . . . . . . . . . . . . . . o@( & & & & & & & & & & & & & & & & & & & & & & & r.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . p@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & C.. . . . . . . . . . . . . . . . l.& & & & & & & n q@. . . . . . . . . . . . . . . r@Z.& & & & & & & & & $@. . . . . . . . . . . . . . . . N.& & & & & & & u x.. . . . . . . . . . . . . . . E.& & & & & & & & & & & & & & & & & & & & & & & & s@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . @@& & & & & & & & & & & & & & & & & & & & & & & & & & & & i e . . . . . . . . . . . . . . . P.u & & & & & & & Z . . . . . . . . . . . . . . . . ~@& & & & & & & & & |+f+. . . . . . . . . . . . . . . G+,.& & & & & & & B.. . . . . . . . . . . . . . . . l.& & & & & & & & & & & & & & & & & & & & & & & & t@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . u@& & & & & & & & & & & & & & & & & & & & & & & & & & & & ) . . . . . . . . . . . . . . . . v@& & & & & & & & u@. . . . . . . . . . . . . . . . p & & & & & & & & & k+. . . . . . . . . . . . . . . . O+& & & & & & & & w@. . . . . . . . . . . . . . . P.u & & & & & & & & & & & & & & & & & & & & & & & & x@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . &.& & & & & & & & & & & & & & & & & & & & & & & & & & & % }.. . . . . . . . . . . . . . . . y@& & & & & & & u z@. . . . . . . . . . . . . . . 5.6.& & & & & & & & & M+. . . . . . . . . . . . . . . . U+& & & & & & & J. +. . . . . . . . . . . . . . . u.& & & & & & & & & & & & & & & & & & & & & & & & & A@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . B@& & & & & & & & & & & & & & & & & & & & & & & & & & & p.. . . . . . . . . . . . . . . . q@n & & & & & & & l.. . . . . . . . . . . . . . . . Z+& & & & & & & & & f @.. . . . . . . . . . . . . . . S+G & & & & & & & #@. . . . . . . . . . . . . . . . q+& & & & & & & & & & & & & & & & & & & & & & & & G f+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . C@& & & & & & & & & & & & & & & & & & & & & & & & & & & D@. . . . . . . . . . . . . . . . j.& & & & & & & & h+. . . . . . . . . . . . . . . . ^.& & & & & & & & & 9.. . . . . . . . . . . . . . . . E@& & & & & & & & /.. . . . . . . . . . . . . . . h@; & & & & & & & & & & & & & & & & & & & & & & & & |+@.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . t+% & & & & & & & & & & & & & & & & & & & & & & & & & 6 F@. . . . . . . . . . . . . . . 4 J & & & & & & & ( {+. . . . . . . . . . . . . . . G@; & & & & & & & & D ).. . . . . . . . . . . . . . . . c.& & & & & & & ] ^ . . . . . . . . . . . . . . . j.& & & & & & & & & & & & & & & & & & & & & & & & & }@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . H@J.& & & & & & & & & & & & & & & & & & & & & & & & & c.. . . . . . . . . . . . . . . . g@D & & & & & & & #@. . . . . . . . . . . . . . . . b.& & & & & & & & & p.. . . . . . . . . . . . . . . . I@; & & & & & & & 5@. . . . . . . . . . . . . . . 4 I+& & & & & & & & & & & & & & & & & & & & & & & & & '@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .+& & & & & & & & & & & & & & & & & & & & & & & & & J@. . . . . . . . . . . . . . . . 2@& & & & & & & & ! . . . . . . . . . . . . . . . . <.& & & & & & & & & K@. . . . . . . . . . . . . . . . a@& & & & & & & & 1 . . . . . . . . . . . . . . . L@D & & & & & & & & & & & & & & & & & & & & & & & & & T . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 2 & & & & & & & & & & & & & & & & & & & & & & & & 6.S+. . . . . . . . . . . . . . . H@I & & & & & & & E + . . . . . . . . . . . . . . . M@% & & & & & & & & ; :+. . . . . . . . . . . . . . . . p.& & & & & & & }@. . . . . . . . . . . . . . . . <+& & & & & & & & & & & & & & & & & & & & & & & & & & N@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . O@& & & & & & & & & & & & & & & & & & & & & & & & 1.. . . . . . . . . . . . . . . . P@& & & & & & & & 5@. . . . . . . . . . . . . . . . N@& & & & & & & & & Z . . . . . . . . . . . . . . . . u+% & & & & & & & b . . . . . . . . . . . . . . . H@I & & & & & & & & & & & & & & & & & & & & & & & & & & %@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . J@& & & & & & & & & & & & & & & & & & & & & & & & Q@. . . . . . . . . . . . . . . . _.& & & & & & & & 1 . . . . . . . . . . . . . . . R@4@& & & & & & & & & u.. . . . . . . . . . . . . . . . 9.& & & & & & & % (@. . . . . . . . . . . . . . . 6@& & & & & & & & & & & & & & & & & & & & & & & & & & & S@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . T@& & & & & & & & & & & & & & & & & & & & & & & ,.A+. . . . . . . . . . . . . . . d@Z.& & & & & & & 7 @.. . . . . . . . . . . . . . . S@& & & & & & & & & u W+. . . . . . . . . . . . . . . . i & & & & & & & l . . . . . . . . . . . . . . . . Q & & & & & & & & & & & & & & & & & & & & & & & & & & ; A@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . {.6.& & & & & & & & & & & & & & & & & & & & & & 6+. . . . . . . . . . . . . . . . : & & & & & & & & b . . . . . . . . . . . . . . . . N+& & & & & & & & & B.. . . . . . . . . . . . . . . . o+& & & & & & & & q . . . . . . . . . . . . . . . A+,.& & & & & & & & & & & & & & & & & & & & & & & & & & 7 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 8+& & & & & & & & & & & & & & & & & & & & & & %.. . . . . . . . . . . . . . . . $.& & & & & & & % } . . . . . . . . . . . . . . . p+U@& & & & & & & & & E.. . . . . . . . . . . . . . . . k+& & & & & & & v w . . . . . . . . . . . . . . . ~@& & & & & & & & & & & & & & & & & & & & & & & & & & & 7+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . w.& & & & & & & & & & & & & & & & & & & & & ..*+. . . . . . . . . . . . . . .  @` & & & & & & & ~ . . . . . . . . . . . . . . . . V@& & & & & & & & & J.W@. . . . . . . . . . . . . . . X@+.& & & & & & & B . . . . . . . . . . . . . . . . 7+& & & & & & & & & & & & & & & & & & & & & & & & & & & b.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . Y@& & & & & & & & & & & & & & & & & & & & & Z@. . . . . . . . . . . . . . . . z & & & & & & & & q . . . . . . . . . . . . . . . . ,+& & & & & & & & & N.. . . . . . . . . . . . . . . . O.& & & & & & & & Z+. . . . . . . . . . . . . . . S+6.& & & & & & & & & & & & & & & & & & & & & & & & & & & C.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ++n & & & & & & & & & & & & & & & & & & & D C . . . . . . . . . . . . . . . . `@& & & & & & & 6 i+. . . . . . . . . . . . . . . -@R & & & & & & & & & Q.. . . . . . . . . . . . . . . . T & & & & & & & `  .. . . . . . . . . . . . . . . J@& & & & & & & & & & & & & & & & & & & & & & & & & & & (  #. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . f.& & & & & & & & & & & & & & & & & & & x . . . . . . . . . . . . . . . . .#6 & & & & & & & B . . . . . . . . . . . . . . . . s+& & & & & & & & & ] +#. . . . . . . . . . . . . . . @#R & & & & & & & $.. . . . . . . . . . . . . . . . ##& & & & & & & & & & & & & & & & & & & & & & & & & & & Y.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . $#& & & & & & & & & & & & & & & & & & & p@. . . . . . . . . . . . . . . . q & & & & & & & & %@. . . . . . . . . . . . . . . . 2 & & & & & & & & & o . . . . . . . . . . . . . . . . V.& & & & & & & & : . . . . . . . . . . . . . . . g.6 & & & & & & & & & & & & & & & & & & & & & & & & & & & b.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 2.& & & & & & & & & & & & & & & & & & n m . . . . . . . . . . . . . . . . ~ & & & & & & & `  @. . . . . . . . . . . . . . . ;+9 & & & & & & & & & 1@. . . . . . . . . . . . . . . . Y.& & & & & & & Z.H.. . . . . . . . . . . . . . . b.& & & & & & & & & & & & & & & & & & & & & & & & & & & % Y+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . *+-+& & & & & & & & & & & & & & & & & |.. . . . . . . . . . . . . . . . Y+% & & & & & & & $.. . . . . . . . . . . . . . . . c & & & & & & & & & .+4 . . . . . . . . . . . . . . . %#9 & & & & & & & *@. . . . . . . . . . . . . . . 4 8+& & & & & & & & & & & & & & & & & & & & & & & & & & & .+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . Q & & & & & & & & & & & & & & & & & c . . . . . . . . . . . . . . . . &#& & & & & & & & ;.. . . . . . . . . . . . . . . . '@& & & & & & & & & @+. . . . . . . . . . . . . . . . D.& & & & & & & & s . . . . . . . . . . . . . . . <@% & & & & & & & & & & & & & & & & & & & & & & & & & & & *#. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . %.& & & & & & & & & & & & & & & & 9 ;+. . . . . . . . . . . . . . . @.7 & & & & & & & Z.R+. . . . . . . . . . . . . . . `.n & & & & & & & & % g . . . . . . . . . . . . . . . . 7@/././././././.B@X . . . . . . . . . . . . . . . N@& & & & & & & & & & & & & & & & & & & & & & & & & & & D c@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . W ..& & & & & & & & & & & & & & & =#. . . . . . . . . . . . . . . . D+& & & & & & & & _.. . . . . . . . . . . . . . . . r & & & & & & & & & A . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . X 4@& & & & & & & & & & & & & & & & & & & & & & & & & & & 3 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 9.& & & & & & & & & & & & & & & &.. . . . . . . . . . . . . . . . < & & & & & & & & s . . . . . . . . . . . . . . . . 3 & & & & & & & & & 4+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 8@& & & & & & & & & & & & & & & & & & & & & & & & & & & & C+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ]@; & & & & & & & & & & & & & ( -#. . . . . . . . . . . . . . . X@-+& & & & & & & I ;#. . . . . . . . . . . . . . . >#& & & & & & & & & v w . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ,#& & & & & & & & & & & & & & & & & & & & & & & & & & & '#w . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . Y.& & & & & & & & & & & & & * . . . . . . . . . . . . . . . . )#& & & & & & & & 9.. . . . . . . . . . . . . . . . O@& & & & & & & & & B . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . b+9 & & & & & & & & & & & & & & & & & & & & & & & & & & & $.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . &+& & & & & & & & & & & & & V@. . . . . . . . . . . . . . . . L & & & & & & & D L@. . . . . . . . . . . . . . . ;#..& & & & & & & & & %@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . d@A & & & & & & & & & & & & & & & & & & & & & & & & & & & & =.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ;#,@& & & & & & & & & & & -+!#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#2+( & & & & & & & J . ~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#%.& & & & & & & & & ` y . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . r@$.& & & & & & & & & & & & & & & & & & & & & & & & & & & & <.3.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . J@& & & & & & & & & & & 9 {#{#{#{#{#{#{#{#{#{#{#{#{#{#{#{#]#& & & & & & & & u {#{#{#{#{#{#{#{#{#{#{#{#{#{#{#{#F & & & & & & & & & ~.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . [+A & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ^#. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . /#I & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ;.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . K.V@* v & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ,@W . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . u.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & Z.{@. . . . . . . . . . . . . . . G+(#U+U+U+U+U+U+U+U+U+U+U+U+U+U+U+U+_#:#.+u & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & &.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . <#4@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & _.. . . . . . . . . . . . . . . . Q@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & J e . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . E.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & s . . . . . . . . . . . . . . . . 1.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & D V@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 4 |.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & H+*+. . . . . . . . . . . . . . . '+6.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & Y.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 1 ; & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 9.. . . . . . . . . . . . . . . . J@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 9 u+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . F.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & V . . . . . . . . . . . . . . . . c.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & R.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . x.[#& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & J 4 . . . . . . . . . . . . . . . g.6 & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 4@d+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ~@% & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & j.. . . . . . . . . . . . . . . . }#& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & |#1#. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . #@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & n h@. . . . . . . . . . . . . . . . 8+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & S . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . S+I & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & Z . . . . . . . . . . . . . . . . M@% & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & I+ +. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 2#v & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ;@. . . . . . . . . . . . . . . . 0 & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & R 3#. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . b.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & u z@. . . . . . . . . . . . . . . t.4@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & % s+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 4 ~.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & l.. . . . . . . . . . . . . . . . S@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 4#. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . b@f.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & E.. . . . . . . . . . . . . . . . '.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & Y.L.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . h@] & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ( d+. . . . . . . . . . . . . . . f+U@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & I+'+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ~+( & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & #@. . . . . . . . . . . . . . . . V@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 5#:+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 6#6.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & /.. . . . . . . . . . . . . . . . * & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & U@}.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . O.u & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & -+f+. . . . . . . . . . . . . . . 7#>@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & |+L@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . e.u & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 5@. . . . . . . . . . . . . . . . s.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & U@L@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . i@` & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 1 . . . . . . . . . . . . . . . . =#& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & I }.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 2#Z.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 7 j . . . . . . . . . . . . . . . &@9 & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & I+5 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . [+i & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & b . . . . . . . . . . . . . . . . i.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & r+K+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . )+Z & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & % Y+. . . . . . . . . . . . . . . . |.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & % $#H@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . f+5@% & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & <.. . . . . . . . . . . . . . . . m n & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & R E.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . O+J.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 4+. . . . . . . . . . . . . . . . v.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 8+8#. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 9#q+& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 6 .#. . . . . . . . . . . . . . . 4 3 & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & 6 N@R+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ^ b.6.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & `@. . . . . . . . . . . . . . . . c@D & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & I+N . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . (@+@& & & & & & & & & & & & & & & & & & & & & & & & & & & & !@. . . . . . . . . . . . . . . . O@& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & j+k.p+. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 3.Q@f & & & & & & & & & & & & & & & & & & & & & & & & & ` }+. . . . . . . . . . . . . . . ^ ..& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ; >.F@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . r@b.H & & & & & & & & & & & & & & & & & & & & & & & $.. . . . . . . . . . . . . . . . 1#& & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & n U+V . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . y v.+.& & & & & & & & & & & & & & & & & & & & & : . . . . . . . . . . . . . . . . Q & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & & ; ~.>#. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . @#c .+& & & & & & & & & & & & & & & & & & Z.G+. . . . . . . . . . . . . . . A+,.& & & & & & & & & & & & & & & & & & & & & & & & & & & & & Z.S `.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 3.Q.p 6.& & & & & & & & & & & & & & & *@. . . . . . . . . . . . . . . . ~@& & & & & & & & & & & & & & & & & & & & & & & & & & & 6 K [ K.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . w+y+^.9 & & & & & & & & & & & & P@. . . . . . . . . . . . . . . . 7+& & & & & & & & & & & & & & & & & & & & & & & & u K D..#. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
"  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 5.&.>.I % & & & & & & & I H@. . . . . . . . . . . . . . . '+6.& & & & & & & & & & & & & & & & & & & & 9 f.< 0#T.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
"  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 4 }@& & & & & & & 2@. . . . . . . . . . . . . . . . Z+& & & & & & & & & & & & & & D v ..Z Q q M+b@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
"  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 8@& & & & & & & D g@. . . . . . . . . . . . . . . . K & & & & & & & & K 4.E+a#b#c#d# #. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
"  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . _.& & & & & & & I+3.. . . . . . . . . . . . . . . ]+6 & & & & & & & & )#. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   ",
"    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . A+,.& & & & & & & _ . . . . . . . . . . . . . . . . b.& & & & & & & & |+H.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .     ",
"    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . &.& & & & & & & n X+. . . . . . . . . . . . . . . 4 8+& & & & & & & & _.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .     ",
"      . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . B & & & & & & & '@. . . . . . . . . . . . . . . . <@% & & & & & & & & 6@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .       ",
"        . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . J+6 & & & & & & & ;@. . . . . . . . . . . . . . . . N@& & & & & & & & e#z.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .         ",
"          . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . v.& & & & & & & u f#. . . . . . . . . . . . . . . X 4@& & & & & & & & o . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .           ",
"            . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 7 & & & & & & & | . . . . . . . . . . . . . . . . 8@& & & & & & & & & 8@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .             ",
"              . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . c+& & & & & & & & w@. . . . . . . . . . . . . . . . < & & & & & & & & T+X . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .               ",
"                . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 6+& & & & & & & ( -@. . . . . . . . . . . . . . . { -+& & & & & & & & 9.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .                 ",
"                    . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . @#J.& & & & & & & L . . . . . . . . . . . . . . . . )#& & & & & & & & & c@. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .                     ",
"                          . . . . . . . . . . . . . . g#h#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#^+& & & & & & & & j#k#k#k#k#k#k#k#k#k#k#k#k#k#k#k#k#,#& & & & & & & & i i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#i#l#j . . . . . . . . . . . .                           ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ",
"                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                "};

GList *
createIconList( ) {
    GdkPixbuf *HPpixbuf  = gdk_pixbuf_new_from_xpm_data( HP_16_xpm );
    GList *iconList = NULL;
    iconList = g_list_append( iconList, HPpixbuf );
    HPpixbuf  = gdk_pixbuf_new_from_xpm_data( HP_32_xpm );
    iconList = g_list_append( iconList, HPpixbuf );
    HPpixbuf  = gdk_pixbuf_new_from_xpm_data( HP_48_xpm );
    iconList = g_list_append( iconList, HPpixbuf );
    HPpixbuf  = gdk_pixbuf_new_from_xpm_data( HP_64_xpm );
    iconList = g_list_append( iconList, HPpixbuf );
    HPpixbuf  = gdk_pixbuf_new_from_xpm_data( HP_128_xpm );
    iconList = g_list_append( iconList, HPpixbuf );
    HPpixbuf  = gdk_pixbuf_new_from_xpm_data( HP_256_xpm );
    iconList = g_list_append( iconList, HPpixbuf );
    return iconList;
}
